/** @file fade.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef FADE_CMDLINE_H
#define FADE_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef FADE_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define FADE_CMDLINE_PARSER_PACKAGE "para_fade"
#endif

#ifndef FADE_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define FADE_CMDLINE_PARSER_VERSION "0.3.5"
#endif

enum enum_mixer_channel { mixer_channel_arg_volume = 0 , mixer_channel_arg_bass, mixer_channel_arg_treble, mixer_channel_arg_synth, mixer_channel_arg_pcm, mixer_channel_arg_speaker, mixer_channel_arg_line, mixer_channel_arg_mic, mixer_channel_arg_cd, mixer_channel_arg_imix, mixer_channel_arg_altpcm, mixer_channel_arg_reclev, mixer_channel_arg_igain, mixer_channel_arg_ogain };

/** @brief Where the command line options are stored */
struct fade_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * mode_arg;	/**< @brief {sleep|fade|snooze} (default='sleep').  */
  char * mode_orig;	/**< @brief {sleep|fade|snooze} original value given at command line.  */
  const char *mode_help; /**< @brief {sleep|fade|snooze} help description.  */
  char * config_file_arg;	/**< @brief (default='~/.paraslash/fade.conf').  */
  char * config_file_orig;	/**< @brief (default='~/.paraslash/fade.conf') original value given at command line.  */
  const char *config_file_help; /**< @brief (default='~/.paraslash/fade.conf') help description.  */
  char * mixer_device_arg;	/**< @brief mixer device file (default='/dev/mixer').  */
  char * mixer_device_orig;	/**< @brief mixer device file original value given at command line.  */
  const char *mixer_device_help; /**< @brief mixer device file help description.  */
  enum enum_mixer_channel mixer_channel_arg;	/**< @brief select the analog mixer channel (default='volume').  */
  char * mixer_channel_orig;	/**< @brief select the analog mixer channel original value given at command line.  */
  const char *mixer_channel_help; /**< @brief select the analog mixer channel help description.  */
  int sleep_ivol_arg;	/**< @brief set initial volume (default='60').  */
  char * sleep_ivol_orig;	/**< @brief set initial volume original value given at command line.  */
  const char *sleep_ivol_help; /**< @brief set initial volume help description.  */
  char * fa_mode_arg;	/**< @brief fall asleep afs mode. (default='m/fade').  */
  char * fa_mode_orig;	/**< @brief fall asleep afs mode. original value given at command line.  */
  const char *fa_mode_help; /**< @brief fall asleep afs mode. help description.  */
  int fa_fade_arg;	/**< @brief fall asleep fading time (default='1800').  */
  char * fa_fade_orig;	/**< @brief fall asleep fading time original value given at command line.  */
  const char *fa_fade_help; /**< @brief fall asleep fading time help description.  */
  int fa_vol_arg;	/**< @brief volume to fade to (default='20').  */
  char * fa_vol_orig;	/**< @brief volume to fade to original value given at command line.  */
  const char *fa_vol_help; /**< @brief volume to fade to help description.  */
  char * sleep_mode_arg;	/**< @brief sleep time afs mode (default='m/sleep').  */
  char * sleep_mode_orig;	/**< @brief sleep time afs mode original value given at command line.  */
  const char *sleep_mode_help; /**< @brief sleep time afs mode help description.  */
  int wake_hour_arg;	/**< @brief (0-23) (default: now + 9 hours).  */
  char * wake_hour_orig;	/**< @brief (0-23) (default: now + 9 hours) original value given at command line.  */
  const char *wake_hour_help; /**< @brief (0-23) (default: now + 9 hours) help description.  */
  int wake_min_arg;	/**< @brief (0-59) (default='0').  */
  char * wake_min_orig;	/**< @brief (0-59) original value given at command line.  */
  const char *wake_min_help; /**< @brief (0-59) help description.  */
  char * wake_mode_arg;	/**< @brief wake time afs mode (default='m/wake').  */
  char * wake_mode_orig;	/**< @brief wake time afs mode original value given at command line.  */
  const char *wake_mode_help; /**< @brief wake time afs mode help description.  */
  int wake_fade_arg;	/**< @brief no fading in if set to 0 (default='1200').  */
  char * wake_fade_orig;	/**< @brief no fading in if set to 0 original value given at command line.  */
  const char *wake_fade_help; /**< @brief no fading in if set to 0 help description.  */
  int wake_vol_arg;	/**< @brief vol to fade to at waketime (default='80').  */
  char * wake_vol_orig;	/**< @brief vol to fade to at waketime original value given at command line.  */
  const char *wake_vol_help; /**< @brief vol to fade to at waketime help description.  */
  int snooze_out_fade_arg;	/**< @brief fade out time (default='30').  */
  char * snooze_out_fade_orig;	/**< @brief fade out time original value given at command line.  */
  const char *snooze_out_fade_help; /**< @brief fade out time help description.  */
  int snooze_out_vol_arg;	/**< @brief vol to fade to before snooze (default='20').  */
  char * snooze_out_vol_orig;	/**< @brief vol to fade to before snooze original value given at command line.  */
  const char *snooze_out_vol_help; /**< @brief vol to fade to before snooze help description.  */
  int snooze_time_arg;	/**< @brief delay (default='600').  */
  char * snooze_time_orig;	/**< @brief delay original value given at command line.  */
  const char *snooze_time_help; /**< @brief delay help description.  */
  int snooze_in_fade_arg;	/**< @brief fade in time (default='180').  */
  char * snooze_in_fade_orig;	/**< @brief fade in time original value given at command line.  */
  const char *snooze_in_fade_help; /**< @brief fade in time help description.  */
  int snooze_in_vol_arg;	/**< @brief vol to fade to after snooze (default='80').  */
  char * snooze_in_vol_orig;	/**< @brief vol to fade to after snooze original value given at command line.  */
  const char *snooze_in_vol_help; /**< @brief vol to fade to after snooze help description.  */
  int fade_vol_arg;	/**< @brief volume to fade to (default='50').  */
  char * fade_vol_orig;	/**< @brief volume to fade to original value given at command line.  */
  const char *fade_vol_help; /**< @brief volume to fade to help description.  */
  int fade_time_arg;	/**< @brief time to fade in (default='5').  */
  char * fade_time_orig;	/**< @brief time to fade in original value given at command line.  */
  const char *fade_time_help; /**< @brief time to fade in help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int mode_given ;	/**< @brief Whether mode was given.  */
  unsigned int config_file_given ;	/**< @brief Whether config_file was given.  */
  unsigned int mixer_device_given ;	/**< @brief Whether mixer_device was given.  */
  unsigned int mixer_channel_given ;	/**< @brief Whether mixer_channel was given.  */
  unsigned int sleep_ivol_given ;	/**< @brief Whether sleep_ivol was given.  */
  unsigned int fa_mode_given ;	/**< @brief Whether fa_mode was given.  */
  unsigned int fa_fade_given ;	/**< @brief Whether fa_fade was given.  */
  unsigned int fa_vol_given ;	/**< @brief Whether fa_vol was given.  */
  unsigned int sleep_mode_given ;	/**< @brief Whether sleep_mode was given.  */
  unsigned int wake_hour_given ;	/**< @brief Whether wake_hour was given.  */
  unsigned int wake_min_given ;	/**< @brief Whether wake_min was given.  */
  unsigned int wake_mode_given ;	/**< @brief Whether wake_mode was given.  */
  unsigned int wake_fade_given ;	/**< @brief Whether wake_fade was given.  */
  unsigned int wake_vol_given ;	/**< @brief Whether wake_vol was given.  */
  unsigned int snooze_out_fade_given ;	/**< @brief Whether snooze_out_fade was given.  */
  unsigned int snooze_out_vol_given ;	/**< @brief Whether snooze_out_vol was given.  */
  unsigned int snooze_time_given ;	/**< @brief Whether snooze_time was given.  */
  unsigned int snooze_in_fade_given ;	/**< @brief Whether snooze_in_fade was given.  */
  unsigned int snooze_in_vol_given ;	/**< @brief Whether snooze_in_vol was given.  */
  unsigned int fade_vol_given ;	/**< @brief Whether fade_vol was given.  */
  unsigned int fade_time_given ;	/**< @brief Whether fade_time was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct fade_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure fade_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure fade_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *fade_args_info_purpose;
/** @brief the usage string of the program */
extern const char *fade_args_info_usage;
/** @brief all the lines making the help output */
extern const char *fade_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *fade_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fade_cmdline_parser (int argc, char * const *argv,
  struct fade_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use fade_cmdline_parser_ext() instead
 */
int fade_cmdline_parser2 (int argc, char * const *argv,
  struct fade_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fade_cmdline_parser_ext (int argc, char * const *argv,
  struct fade_args_info *args_info,
  struct fade_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fade_cmdline_parser_dump(FILE *outfile,
  struct fade_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fade_cmdline_parser_file_save(const char *filename,
  struct fade_args_info *args_info);

/**
 * Print the help
 */
void fade_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void fade_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void fade_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a fade_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void fade_cmdline_parser_params_init(struct fade_cmdline_parser_params *params);

/**
 * Allocates dynamically a fade_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized fade_cmdline_parser_params structure
 */
struct fade_cmdline_parser_params *fade_cmdline_parser_params_create(void);

/**
 * Initializes the passed fade_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void fade_cmdline_parser_init (struct fade_args_info *args_info);
/**
 * Deallocates the string fields of the fade_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void fade_cmdline_parser_free (struct fade_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use fade_cmdline_parser_config_file() instead
 */
int fade_cmdline_parser_configfile (char * const filename,
  struct fade_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int fade_cmdline_parser_config_file (char * const filename,
  struct fade_args_info *args_info,
  struct fade_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int fade_cmdline_parser_required (struct fade_args_info *args_info,
  const char *prog_name);

extern char *fade_cmdline_parser_mixer_channel_values[] ;	/**< @brief Possible values for mixer_channel.  */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* FADE_CMDLINE_H */
